var maxAnimationTime = 3;
var developmentmode = true;
var loopDuration;
var maxLoops;
var canvasWidth;
var canvasHeight;
var loops = 0;
var master;
var done= false;

///////////////////// init ///////////////////// 

function init() {
	checkCanvasSize();	 
	setMasterTimeline();
	createTimeLine();

}

///////////////////// animations ///////////////////// 


function setPositions(){

	var tl = new TimelineMax();
  
  tl.set("#banner", {autoAlpha: 1},0);
  



	return tl;
}

	function frame1(){

	var tl = new TimelineMax({});

/*	if (!(/Edge/.test(navigator.userAgent))) {}*/



  tl.from(".bg", {scale:1.2, rotation:1, duration: 10, ease:"power1.out", transformOrigin:"center center"},0)  
  tl.from(".text1", {y:10, autoAlpha:0, duration: 1, ease:"power3.out"},0.2)  

  tl.from(".frame2", {yPercent:100, duration: 1.5, ease:"expo.inOut"},3)  
  tl.from(".text2", {y:15, autoAlpha:0, duration: 1.5, ease:"power3.out"},4) 

  tl.from(".cta", {autoAlpha:0, duration:.8, ease:"power1.in"},4.5)  

  tl.to(".text3", {clip:"rect(0px,250px,600px,90px)", duration:1.5, ease:"power1.inOut"},5);

  // tl.from(".logo", {y:-50, duration: 1, ease:"power3.out"},0)

	return tl;
  }

  function frame2(){

  var tl = new TimelineMax({});



/*  if (!(/Edge/.test(navigator.userAgent))) {}*/

  return tl;
  }

  function frame3(){

  var tl = new TimelineMax({});



  return tl;
  }

  function frame4(){

  var tl = new TimelineMax({});



  return tl;
  }

function aniDone(){
 done = true;

}



function loop(){
  var tl = new TimelineMax();



  return tl;
}


function createTimeLine() {

	// default
	master.add(setPositions());
	
	// animation
	master.add(frame1(), 0);



	master.add(checkLoops,"+=1")
	master.add(loop(),"+=0");
	
}

///////////////////// functions ///////////////////// 

function setMasterTimeline(){
	master = new TimelineMax({
			onStart: function() {
								loopDuration = master.duration() / master.timeScale()	
								maxLoops = Math.floor(maxAnimationTime/loopDuration);

								log("loopDuration:", loopDuration)
								log("maxLoops:", maxLoops)				
 
			},			
			repeat:-1,

		});
}


function rollOver() {

if (done){
	
}
  gsap.set(".ctaActive", {display: "block"});
  gsap.set(".ctaInActive", {display: "none"});

};

function rollOut() {

  gsap.set(".ctaActive", {display: "none"});
  gsap.set(".ctaInActive", {display: "block"});

};


function checkLoops() {

    if (loops === maxLoops || maxLoops === 0) {
        master.pause();
        log("animationDone")
    }
  
    loops++

};

function log(name, element){
    if (developmentmode){
        if(element === undefined){
            element = ""
        }
        console.log(name, element)
    }
}



function checkCanvasSize() {
    canvasWidth = document.getElementById('banner').offsetWidth;
    canvasHeight = document.getElementById('banner').offsetHeight;
    log("canvasWidth" ,canvasWidth)
    log("canvasHeight" ,canvasHeight)  
};


function mouseMovement(el, target){



    document.getElementById(el).addEventListener("mousemove", mouseMoving);
    var target = document.getElementById(target)

    function mouseMoving(e){

   	    element = this;

        mouseX = e.offsetX;
        mouseY = e.offsetY;

        update(element, target)

    };
    

    function update(){

    //log("randomNumber", gsapRandomNumber(0,100))
    
        var gsapMouseToRotation = gsap.utils.pipe(
		        gsap.utils.clamp(0, element.offsetWidth),
		        gsap.utils.mapRange(0, element.offsetWidth, -10, 0),
		        gsap.utils.snap(1)

   	);
    if (done){
    gsap.to(target, {duration:.25, y:-gsapMouseToRotation(mouseY)/2, x:-gsapMouseToRotation(mouseX)/2,  rotation:gsapMouseToRotation(mouseX), overwrite:"all", ease:"power1.easeOut"});
  }
    }
};









